package fr.sanchezm.attestationsCovid19.data.db

import android.content.Context
import fr.sanchezm.attestationsCovid19.data.db.dao.AttestationDao
import fr.sanchezm.attestationsCovid19.data.db.dao.ConfigDao
import fr.sanchezm.attestationsCovid19.data.db.dao.ProfileDao
import fr.sanchezm.attestationsCovid19.data.repository.ConfigRepository

class MyDatabase private constructor(private val savePath: String, private val filesPath: String) {

    private var _profileDao: ProfileDao? = null
    private var _attestationDao: AttestationDao? = null
    private var _configDao: ConfigDao? = null

    fun profileDao(configRepository: ConfigRepository): ProfileDao =
        _profileDao ?: ProfileDao(savePath, configRepository).also { _profileDao = it }

    fun attestationDao(configRepository: ConfigRepository): AttestationDao =
        _attestationDao ?: AttestationDao(
            savePath,
            filesPath,
            configRepository
        ).also { _attestationDao = it }

    fun configDao(): ConfigDao = _configDao ?: ConfigDao(savePath).also { _configDao = it }

    companion object {
        @Volatile
        private var instance: MyDatabase? = null
        private val LOCK = Any()

        operator fun invoke(context: Context, filesPath: String) = instance ?: synchronized(LOCK) {
            instance ?: MyDatabase(context.filesDir.path, filesPath).also { instance = it }
        }
    }
}
